import datetime

"""
This file contains definitions for Task class and its subclasses. 
"""


class Task:
    """
    An abstract class used to create hierarchy and upcasts/downcasts when working with tasks.
    """
    pass


class RequestTsInfoTask(Task):
    """
    Subclass of a Task class, contains data needed to request data about a vehicle from https://nsis.ru/products/osago/check/.
    """

    def __init__(self, license_plate: str, prior_to_date: datetime):
        self.license_plate = license_plate
        self.prior_to_date = prior_to_date
