from datetime import date

from src.dataclasses.task import RequestTsInfoTask, Task


class Broker:
    """
    Serves as a dummy broker to simulate broker's work and supply workers with tasks queue
    """
    def __init__(self):
        """
        Task queue is a list that contains tasks sorted by their priority
        """

        self.tasks_queue = list()
        self.tasks_queue.append(RequestTsInfoTask("М976ММ777", date.today()))
        

    def get_task(self) -> Task | None:
        """
        Return uncompleted task with the highest priority.
        Return None if no tasks are available.
        """
        if len(self.tasks_queue) == 0: return None
        task = self.tasks_queue.pop()
        return task