from io import FileIO
from sys import stdout
from time import time
from typing import IO

from src.dataclasses.loglevels import LogLevels


class Logger:
    """
    Logger is a class that handles logging to the STDOUT of a file.
    Upon creating one must specify the maximum log level.
    Logger will not log the messages with
    """

    def __init__(self, loglevel: LogLevels, place_to_log: stdout or IO):
        self.loglevel = loglevel
        self.place_to_log = place_to_log

    def debug(self, message):
        if self.loglevel > LogLevels.DEBUG: return
        self.place_to_log.write(f"[DEBUG] <{time()}> {message}\n")

    def info(self, message):
        if self.loglevel > LogLevels.INFO: return
        self.place_to_log.write(f"[INFO] <{time()}> {message}\n")

    def warning(self, message):
        if self.loglevel > LogLevels.WARNING: return
        self.place_to_log.write(f"[WARNING] <{time()}> {message}\n")

    def error(self, message):
        if self.loglevel > LogLevels.ERROR: return
        self.place_to_log.write(f"[ERROR] <{time}> {message}\n")